Loading...
Searching...
No Matches
juce::Button Class Referenceabstract

## Detailed Description

A base class for buttons.

This contains all the logic for button behaviours such as enabling/disabling, responding to shortcut keystrokes, auto-repeating when held down, toggle-buttons and radio groups, etc.

See also
  TextButton, DrawableButton, ToggleButton

The documentation for this class was generated from the following file:

- juce_gui_basics/buttons/juce_Button.h

Inheritance diagram for juce::Button:

## Classes

class | Listener
| Used to receive callbacks when a button is clicked. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide button-drawing functionality. More...

## Public Types

enum | ConnectedEdgeFlags { ConnectedOnLeft = 1 , ConnectedOnRight = 2 , ConnectedOnTop = 4 , ConnectedOnBottom = 8 }
| A combination of these flags are used by setConnectedEdges(). More...
enum | ButtonState { buttonNormal , buttonOver , buttonDown }
| Used by setState(). More...
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| ~Button () override
| Destructor.
void | setButtonText (const String &newText)
| Changes the button's text.
const String & | getButtonText () const
| Returns the text displayed in the button.
bool | isDown () const noexcept
| Returns true if the button is currently being held down.
bool | isOver () const noexcept
| Returns true if the mouse is currently over the button.
void | setToggleable (bool shouldBeToggleable)
| Indicates that the button's on/off state is toggleable.
bool | isToggleable () const noexcept
| Returns true if the button's on/off state is toggleable.
void | setToggleState (bool shouldBeOn, NotificationType notification)
| A button has an on/off state associated with it, and this changes that.
bool | getToggleState () const noexcept
| Returns true if the button is 'on'.
Value & | getToggleStateValue () noexcept
| Returns the Value object that represents the button's toggle state.
void | setClickingTogglesState (bool shouldAutoToggleOnClick) noexcept
| This tells the button to automatically flip the toggle state when the button is clicked.
bool | getClickingTogglesState () const noexcept
| Returns true if this button is set to be an automatic toggle-button.
void | setRadioGroupId (int newGroupId, NotificationType notification=sendNotification)
| Enables the button to act as a member of a mutually-exclusive group of 'radio buttons'.
int | getRadioGroupId () const noexcept
| Returns the ID of the group to which this button belongs.
void | addListener (Listener *newListener)
| Registers a listener to receive events when this button's state changes.
void | removeListener (Listener *listener)
| Removes a previously-registered button listener.
virtual void | triggerClick ()
| Causes the button to act as if it's been clicked.
void | setCommandToTrigger (ApplicationCommandManager *commandManagerToUse, CommandID commandID, bool generateTooltip)
| Sets a command ID for this button to automatically invoke when it's clicked.
CommandID | getCommandID () const noexcept
| Returns the command ID that was set by setCommandToTrigger().
void | addShortcut (const KeyPress &)
| Assigns a shortcut key to trigger the button.
void | clearShortcuts ()
| Removes all key shortcuts that had been set for this button.
bool | isRegisteredForShortcut (const KeyPress &) const
| Returns true if the given keypress is a shortcut for this button.
void | setRepeatSpeed (int initialDelayInMillisecs, int repeatDelayInMillisecs, int minimumDelayInMillisecs=-1) noexcept
| Sets an auto-repeat speed for the button when it is held down.
void | setTriggeredOnMouseDown (bool isTriggeredOnMouseDown) noexcept
| Sets whether the button click should happen when the mouse is pressed or released.
bool | getTriggeredOnMouseDown () const noexcept
| Returns whether the button click happens when the mouse is pressed or released.
uint32 | getMillisecondsSinceButtonDown () const noexcept
| Returns the number of milliseconds since the last time the button went into the 'down' state.
void | setTooltip (const String &newTooltip) override
| Sets the tooltip for this button.
void | setConnectedEdges (int connectedEdgeFlags)
| Hints about which edges of the button might be connected to adjoining buttons.
int | getConnectedEdgeFlags () const noexcept
| Returns the set of flags passed into setConnectedEdges().
bool | isConnectedOnLeft () const noexcept
| Indicates whether the button adjoins another one on its left edge.
bool | isConnectedOnRight () const noexcept
| Indicates whether the button adjoins another one on its right edge.
bool | isConnectedOnTop () const noexcept
| Indicates whether the button adjoins another one on its top edge.
bool | isConnectedOnBottom () const noexcept
| Indicates whether the button adjoins another one on its bottom edge.
void | setState (ButtonState newState)
| Can be used to force the button into a particular state.
ButtonState | getState () const noexcept
| Returns the button's current over/down/up state.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | resized ()
| Called when this component's size has been changed.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from juce::SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor.
String | getTooltip () override
| Returns the tooltip assigned to this object.
Public Member Functions inherited from juce::TooltipClient
virtual | ~TooltipClient ()=default
| Destructor.

## Public Attributes

std::function< void()> | onClick
| You can assign a lambda to this callback object to have it called when the button is clicked.
std::function< void()> | onStateChange
| You can assign a lambda to this callback object to have it called when the button's state changes.

## Protected Member Functions

| Button (const String &buttonName)
| Creates a button.
virtual void | clicked ()
| This method is called when the button has been clicked.
virtual void | clicked (const ModifierKeys &modifiers)
| This method is called when the button has been clicked.
virtual void | paintButton (Graphics &g, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown)=0
| Subclasses should override this to actually paint the button's contents.
virtual void | buttonStateChanged ()
| Called when the button's up/down/over state changes.
virtual void | internalClickCallback (const ModifierKeys &)
void | handleCommandMessage (int commandId) override
| Called to handle a command that was sent by postCommandMessage().
void | mouseEnter (const MouseEvent &) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | parentHierarchyChanged () override
| Called to indicate that the component's parents have changed.
void | visibilityChanged () override
| Called when this component's visibility changes.
void | focusGained (FocusChangeType) override
| Called to indicate that this component has just acquired the keyboard focus.
void | focusLost (FocusChangeType) override
| Called to indicate that this component has just lost the keyboard focus.
void | enablementChanged () override
| Callback to indicate that this component has been enabled or disabled.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
Protected Member Functions inherited from juce::SettableTooltipClient
| SettableTooltipClient ()=default

## Additional Inherited Members

Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Member Enums

## ConnectedEdgeFlags

enum juce::Button::ConnectedEdgeFlags

A combination of these flags are used by setConnectedEdges().

Enumerator
ConnectedOnLeft |
ConnectedOnRight |
ConnectedOnTop |
ConnectedOnBottom |

## ButtonState

enum juce::Button::ButtonState

Used by setState().

Enumerator
buttonNormal |
buttonOver |
buttonDown |

## Constructors and Destructors

## Button()

juce::Button::Button | ( | const String & | buttonName | ) |

explicit protected

Creates a button.

Parameters

  buttonName | the text to put in the button (the component's name is also initially set to this string, but these can be changed later using the setName() and setButtonText() methods)

Referenced by juce::Button::Listener::buttonClicked(), juce::Button::Listener::buttonStateChanged(), and juce::Button::LookAndFeelMethods::drawButtonBackground().

## ~Button()

juce::Button::~Button | ( |  | ) |

override

Destructor.

## Member Functions

## setButtonText()

void juce::Button::setButtonText | ( | const String & | newText | ) |

Changes the button's text.

See also
  getButtonText

## getButtonText()

const String & juce::Button::getButtonText | ( |  | ) | const

inline

Returns the text displayed in the button.

See also
  setButtonText

## isDown()

bool juce::Button::isDown | ( |  | ) | const

noexcept

Returns true if the button is currently being held down.

See also
  isOver

## isOver()

bool juce::Button::isOver | ( |  | ) | const

noexcept

Returns true if the mouse is currently over the button.

This will be also be true if the button is being held down.

See also
  isDown

References isOver().

Referenced by isOver().

## setToggleable()

void juce::Button::setToggleable | ( | bool | shouldBeToggleable | ) |

Indicates that the button's on/off state is toggleable.

By default this is false, and will only be true for ToggleButtons, buttons that are a part of a radio button group, and buttons for which getClickingTogglesState() == true, however you can use this method to manually indicate that a button is toggleable.

This will present the button as toggleable to accessibility clients and add an accessible "toggle" action for the button that invokes setToggleState().

See also
  ToggleButton, isToggleable, setToggleState, setClickingTogglesState, setRadioGroupId

References setToggleable().

Referenced by setToggleable().

## isToggleable()

bool juce::Button::isToggleable | ( |  | ) | const

inline noexcept

Returns true if the button's on/off state is toggleable.

See also
  setToggleable, setClickingTogglesState

References isToggleable().

Referenced by isToggleable().

## setToggleState()

void juce::Button::setToggleState | ( | bool | shouldBeOn,
|  | NotificationType | notification )

A button has an on/off state associated with it, and this changes that.

By default buttons are 'off' and for simple buttons that you click to perform an action you won't change this. Toggle buttons, however will want to change their state when turned on or off.

Parameters

  shouldBeOn | whether to set the button's toggle state to be on or off. If it's a member of a button group, this will always try to turn it on, and to turn off any other buttons in the group
  notification | determines the behaviour if the value changes - this can invoke a synchronous call to clicked(), but sendNotificationAsync is not supported

See also
  getToggleState, setRadioGroupId

## getToggleState()

bool juce::Button::getToggleState | ( |  | ) | const

inline noexcept

Returns true if the button is 'on'.

By default buttons are 'off' and for simple buttons that you click to perform an action you won't change this. Toggle buttons, however will want to change their state when turned on or off.

See also
  setToggleState

## getToggleStateValue()

Value & juce::Button::getToggleStateValue | ( |  | ) |

inline noexcept

Returns the Value object that represents the button's toggle state.

You can use this Value object to connect the button's state to external values or setters, either by taking a copy of the Value, or by using Value::referTo() to make it point to your own Value object.

See also
  getToggleState, Value

## setClickingTogglesState()

void juce::Button::setClickingTogglesState | ( | bool | shouldAutoToggleOnClick | ) |

noexcept

This tells the button to automatically flip the toggle state when the button is clicked.

If set to true, then before the clicked() callback occurs, the toggle-state of the button is flipped. This will also cause isToggleable() to return true.

See also
  isToggleable

## getClickingTogglesState()

bool juce::Button::getClickingTogglesState | ( |  | ) | const

inline noexcept

Returns true if this button is set to be an automatic toggle-button.

This returns the last value that was passed to setClickingTogglesState().

## setRadioGroupId()

void juce::Button::setRadioGroupId | ( | int | newGroupId,
|  | NotificationType | notification = sendNotification )

Enables the button to act as a member of a mutually-exclusive group of 'radio buttons'.

If the group ID is set to a non-zero number, then this button will act as part of a group of buttons with the same ID, only one of which can be 'on' at the same time. Note that when it's part of a group, clicking a toggle-button that's 'on' won't turn it off.

To find other buttons with the same ID, this button will search through its sibling components for ToggleButtons, so all the buttons for a particular group must be placed inside the same parent component.

Set the group ID back to zero if you want it to act as a normal toggle button again.

The notification argument lets you specify how other buttons should react to being turned on or off in response to this call.

See also
  getRadioGroupId

References juce::sendNotification.

## getRadioGroupId()

int juce::Button::getRadioGroupId | ( |  | ) | const

inline noexcept

Returns the ID of the group to which this button belongs.

(See setRadioGroupId() for an explanation of this).

## addListener()

void juce::Button::addListener | ( | Listener * | newListener | ) |

Registers a listener to receive events when this button's state changes.

If the listener is already registered, this will not register it again.

See also
  removeListener

## removeListener()

void juce::Button::removeListener | ( | Listener * | listener | ) |

Removes a previously-registered button listener.

See also
  addListener

## triggerClick()

virtual void juce::Button::triggerClick | ( |  | ) |

virtual

Causes the button to act as if it's been clicked.

This will asynchronously make the button draw itself going down and up, and will then call back the clicked() method as if mouse was clicked on it.

See also
  clicked

## setCommandToTrigger()

void juce::Button::setCommandToTrigger | ( | ApplicationCommandManager * | commandManagerToUse,
|  | CommandID | commandID,
|  | bool | generateTooltip )

Sets a command ID for this button to automatically invoke when it's clicked.

When the button is pressed, it will use the given manager to trigger the command ID.

Obviously be careful that the ApplicationCommandManager doesn't get deleted before this button is. To disable the command triggering, call this method and pass nullptr as the command manager.

If generateTooltip is true, then the button's tooltip will be automatically generated based on the name of this command and its current shortcut key.

See also
  addShortcut, getCommandID

## getCommandID()

CommandID juce::Button::getCommandID | ( |  | ) | const

inline noexcept

Returns the command ID that was set by setCommandToTrigger().

## addShortcut()

void juce::Button::addShortcut | ( | const KeyPress & |  | ) |

Assigns a shortcut key to trigger the button.

The button registers itself with its top-level parent component for keypresses.

Note that a different way of linking buttons to keypresses is by using the setCommandToTrigger() method to invoke a command.

See also
  clearShortcuts

## clearShortcuts()

void juce::Button::clearShortcuts | ( |  | ) |

Removes all key shortcuts that had been set for this button.

See also
  addShortcut

## isRegisteredForShortcut()

bool juce::Button::isRegisteredForShortcut | ( | const KeyPress & |  | ) | const

Returns true if the given keypress is a shortcut for this button.

See also
  addShortcut

## setRepeatSpeed()

void juce::Button::setRepeatSpeed | ( | int | initialDelayInMillisecs,
|  | int | repeatDelayInMillisecs,
|  | int | minimumDelayInMillisecs = -1 )

noexcept

Sets an auto-repeat speed for the button when it is held down.

(Auto-repeat is disabled by default).

Parameters

  initialDelayInMillisecs | how long to wait after the mouse is pressed before triggering the next click. If this is zero, auto-repeat is disabled
  repeatDelayInMillisecs | the frequently subsequent repeated clicks should be triggered
  minimumDelayInMillisecs | if this is greater than 0, the auto-repeat speed will get faster, the longer the button is held down, up to the minimum interval specified here

## setTriggeredOnMouseDown()

void juce::Button::setTriggeredOnMouseDown | ( | bool | isTriggeredOnMouseDown | ) |

noexcept

Sets whether the button click should happen when the mouse is pressed or released.

By default the button is only considered to have been clicked when the mouse is released, but setting this to true will make it call the clicked() method as soon as the button is pressed.

This is useful if the button is being used to show a pop-up menu, as it allows the click to be used as a drag onto the menu.

References setTriggeredOnMouseDown().

Referenced by setTriggeredOnMouseDown().

## getTriggeredOnMouseDown()

bool juce::Button::getTriggeredOnMouseDown | ( |  | ) | const

noexcept

Returns whether the button click happens when the mouse is pressed or released.

See also
  setTriggeredOnMouseDown

References getTriggeredOnMouseDown().

Referenced by getTriggeredOnMouseDown().

## getMillisecondsSinceButtonDown()

uint32 juce::Button::getMillisecondsSinceButtonDown | ( |  | ) | const

noexcept

Returns the number of milliseconds since the last time the button went into the 'down' state.

References getMillisecondsSinceButtonDown().

Referenced by getMillisecondsSinceButtonDown().

## setTooltip()

void juce::Button::setTooltip | ( | const String & | newTooltip | ) |

override virtual

Sets the tooltip for this button.

See also
  TooltipClient, TooltipWindow

Reimplemented from juce::SettableTooltipClient.

References setTooltip().

Referenced by setTooltip().

## setConnectedEdges()

void juce::Button::setConnectedEdges | ( | int | connectedEdgeFlags | ) |

Hints about which edges of the button might be connected to adjoining buttons.

The value passed in is a bitwise combination of any of the values in the ConnectedEdgeFlags enum.

E.g. if you are placing two buttons adjacent to each other, you could use this to indicate which edges are touching, and the LookAndFeel might choose to drawn them without rounded corners on the edges that connect. It's only a hint, so the LookAndFeel can choose to ignore it if it's not relevant for this type of button.

## getConnectedEdgeFlags()

int juce::Button::getConnectedEdgeFlags | ( |  | ) | const

inline noexcept

Returns the set of flags passed into setConnectedEdges().

## isConnectedOnLeft()

bool juce::Button::isConnectedOnLeft | ( |  | ) | const

inline noexcept

Indicates whether the button adjoins another one on its left edge.

See also
  setConnectedEdges

References ConnectedOnLeft.

## isConnectedOnRight()

bool juce::Button::isConnectedOnRight | ( |  | ) | const

inline noexcept

Indicates whether the button adjoins another one on its right edge.

See also
  setConnectedEdges

References ConnectedOnRight.

## isConnectedOnTop()

bool juce::Button::isConnectedOnTop | ( |  | ) | const

inline noexcept

Indicates whether the button adjoins another one on its top edge.

See also
  setConnectedEdges

References ConnectedOnTop.

## isConnectedOnBottom()

bool juce::Button::isConnectedOnBottom | ( |  | ) | const

inline noexcept

Indicates whether the button adjoins another one on its bottom edge.

See also
  setConnectedEdges

References ConnectedOnBottom.

## setState()

void juce::Button::setState | ( | ButtonState | newState | ) |

Can be used to force the button into a particular state.

This only changes the button's appearance, it won't trigger a click, or stop any mouse-clicks from happening.

The state that you set here will only last until it is automatically changed when the mouse enters or exits the button, or the mouse-button is pressed or released.

## getState()

ButtonState juce::Button::getState | ( |  | ) | const

inline noexcept

Returns the button's current over/down/up state.

## clicked() [1/2]

virtual void juce::Button::clicked | ( |  | ) |

protected virtual

This method is called when the button has been clicked.

Subclasses can override this to perform whatever actions they need to do. In general, you wouldn't use this method to receive clicks, but should get your callbacks by attaching a std::function to the onClick callback, or adding a Button::Listener.

See also
  triggerClick, onClick

Reimplemented in juce::HyperlinkButton.

Referenced by juce::HyperlinkButton::paintButton().

## clicked() [2/2]

virtual void juce::Button::clicked | ( | const ModifierKeys & | modifiers | ) |

protected virtual

This method is called when the button has been clicked.

By default it just calls clicked(), but you might want to override it to handle things like clicking when a modifier key is pressed, etc.

See also
  ModifierKeys

Reimplemented in juce::TabBarButton.

## paintButton()

virtual void juce::Button::paintButton | ( | Graphics & | g,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )

protected pure virtual

Subclasses should override this to actually paint the button's contents.

It's better to use this than the paint method, because it gives you information about the over/down state of the button.

Parameters

  g | the graphics context to use
  shouldDrawButtonAsHighlighted | true if the button is either in the 'over' or 'down' state
  shouldDrawButtonAsDown | true if the button should be drawn in the 'down' position

Implemented in juce::ArrowButton, juce::DrawableButton, juce::HyperlinkButton, juce::ImageButton, juce::ShapeButton, juce::TabBarButton, juce::TextButton, juce::ToggleButton, and juce::ToolbarItemComponent.

## buttonStateChanged()

virtual void juce::Button::buttonStateChanged | ( |  | ) |

protected virtual

Called when the button's up/down/over state changes.

Subclasses can override this if they need to do something special when the button goes up or down.

See also
  isDown, isOver

Reimplemented in juce::DrawableButton, and juce::ToolbarButton.

## internalClickCallback()

virtual void juce::Button::internalClickCallback | ( | const ModifierKeys & |  | ) |

protected virtual

## handleCommandMessage()

void juce::Button::handleCommandMessage | ( | int | commandId | ) |

override protected virtual

Called to handle a command that was sent by postCommandMessage().

This is called by the message thread when a command message arrives, and the component can override this method to process it in any way it needs to.

See also
  postCommandMessage

Reimplemented from juce::Component.

## mouseEnter()

void juce::Button::mouseEnter | ( | const MouseEvent & | event | ) |

override protected virtual

Called when the mouse first enters a component.

If the mouse button isn't pressed and the mouse moves into a component, this will be called to let the component react to this.

When the mouse button is pressed and held down while being moved in or out of a component, no mouseEnter or mouseExit callbacks are made - only mouseDrag messages are sent to the component that the mouse was originally clicked on, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseExit, mouseDrag, mouseMove, contains

Reimplemented from juce::MouseListener.

## mouseExit()

void juce::Button::mouseExit | ( | const MouseEvent & | event | ) |

override protected virtual

Called when the mouse moves out of a component.

This will be called when the mouse moves off the edge of this component.

If the mouse button was pressed, and it was then dragged off the edge of the component and released, then this callback will happen when the button is released, after the mouseUp callback.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseDrag, mouseMove, contains

Reimplemented from juce::MouseListener.

## mouseDown()

void juce::Button::mouseDown | ( | const MouseEvent & | event | ) |

override protected virtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::MouseListener.

## mouseDrag()

void juce::Button::mouseDrag | ( | const MouseEvent & | event | ) |

override protected virtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from juce::MouseListener.

## mouseUp()

void juce::Button::mouseUp | ( | const MouseEvent & | event | ) |

override protected virtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::MouseListener.

## keyPressed()

bool juce::Button::keyPressed | ( | const KeyPress & | key | ) |

override protected virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

References juce::Component::keyStateChanged().

## paint()

void juce::Button::paint | ( | Graphics & | g | ) |

override protected virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from juce::Component.

## parentHierarchyChanged()

void juce::Button::parentHierarchyChanged | ( |  | ) |

override protected virtual

Called to indicate that the component's parents have changed.

When a component is added or removed from its parent, this method will be called on all of its children (recursively - so all children of its children will also be called as well).

Subclasses can override this if they need to react to this in some way.

See also
  getParentComponent, isShowing, ComponentListener::componentParentHierarchyChanged

Reimplemented from juce::Component.

## visibilityChanged()

void juce::Button::visibilityChanged | ( |  | ) |

override protected virtual

Called when this component's visibility changes.

See also
  setVisible, isVisible

Reimplemented from juce::Component.

## focusGained()

void juce::Button::focusGained | ( | FocusChangeType | cause | ) |

override protected virtual

Called to indicate that this component has just acquired the keyboard focus.

See also
  focusLost, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## focusLost()

void juce::Button::focusLost | ( | FocusChangeType | cause | ) |

override protected virtual

Called to indicate that this component has just lost the keyboard focus.

See also
  focusGained, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## enablementChanged()

void juce::Button::enablementChanged | ( |  | ) |

override protected virtual

Callback to indicate that this component has been enabled or disabled.

This can be triggered by one of the component's parent components being enabled or disabled, as well as changes to the component itself.

The default implementation of this method does nothing; your class may wish to repaint itself or something when this happens.

See also
  setEnabled, isEnabled

Reimplemented from juce::Component.

Reimplemented in juce::DrawableButton, and juce::ToolbarButton.

## createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > juce::Button::createAccessibilityHandler | ( |  | ) |

override protected virtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from juce::Component.

Reimplemented in juce::HyperlinkButton, juce::ToggleButton, and juce::ToolbarItemComponent.

## keyStateChanged()

virtual bool juce::Component::keyStateChanged | ( | bool | isKeyDown | ) |

protected virtual

Called when a key is pressed or released.

Whenever a key on the keyboard is pressed or released (including modifier keys like shift and ctrl), this method will be called on the component that currently has the keyboard focus. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, then any KeyListeners that have been registered with this component will have their keyStateChanged methods called. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

To find out which keys are up or down at any time, see the KeyPress::isKeyCurrentlyDown() method.

Parameters

  isKeyDown | true if a key has been pressed; false if it has been released

See also
  keyPressed, KeyPress, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## Member Data Documentation

## onClick

std::function<void()> juce::Button::onClick

You can assign a lambda to this callback object to have it called when the button is clicked.

## onStateChange

std::function<void()> juce::Button::onStateChange

You can assign a lambda to this callback object to have it called when the button's state changes.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited